STREAMLINK(1)

NAME
streamlink - extracts streams from various services and pipes them into a video player of choice

TUTORIAL

Streamlink is a command-line application, which means that the commands described here should be typed into a terminal. On Windows, you have to open either the Command Prompt, PowerShell or Windows Terminal, on macOS open the Terminal app, and if you're on Linux or BSD you probably already know the drill.

The way Streamlink works is that it's only a means to extract and transport the streams, and the playback is done by an external video player. Streamlink works best with VLC or mpv, which are also cross-platform, but other players may be compatible too, see the Players page for a complete overview.

Now to get into actually using Streamlink, let's say you want to watch the stream located on twitch.tv/day9tv, you start off by telling Streamlink where to attempt to extract streams from. This is done by giving the URL to the command streamlink as the first argument:

$ streamlink twitch.tv/day9tv
[cli][info] Found matching plugin twitch for URL twitch.tv/day9tv
Available streams: audio, high, low, medium, mobile (worst), source (best)

NOTE: You don't need to include the protocol when dealing with HTTP(s) URLs, e.g. just twitch.tv/day9tv is enough and quicker to type.

This command will tell Streamlink to attempt to extract streams from the URL specified, and if it's successful, print out a list of available streams to choose from.

In some cases (Supported streaming protocols) local files are supported using the file:// protocol, for example a local HLS playlist can be played. Relative file paths and absolute paths are supported. All path separators are /, even on Windows.

$ streamlink hls://file://C:/hls/playlist.m3u8
[cli][info] Found matching plugin stream for URL hls://file://C:/hls/playlist.m3u8
Available streams: 180p (worst), 272p, 408p, 554p, 818p, 1744p (best)

To select a stream and start playback, simply add the stream name as a second argument to the streamlink command:

$ streamlink twitch.tv/day9tv 1080p60
[cli][info] Found matching plugin twitch for URL twitch.tv/day9tv
[cli][info] Opening stream: 1080p60 (hls)
[cli][info] Starting player: vlc

The stream you chose should now be playing in the player. It's a common use case to just want to start the highest quality stream and not be bothered with what it's named. To do this, just specify best as the stream name and Streamlink will attempt to rank the streams and open the one of highest quality. You can also specify worst to get the lowest quality.

Now that you have a basic grasp of how Streamlink works, you may want to look into customizing it to your own needs, such as:

•   Creating a configuration file of options you want to use

•   Setting up your player to cache some data before playing the stream to help avoiding buffering issues

CONFIGURATION FILE

Writing the command-line options every time is inconvenient, that's why Streamlink is capable of reading options from a configuration file instead.

Streamlink will look for config files in different locations depending on your platform:
Platform | Location
Unix-like (POSIX) | $XDG_CONFIG_HOME/streamlink/config ~/.streamlinkrc
Windows | %APPDATA%\streamlink\streamlinkrc

You can also specify the location yourself using the --config option.

NOTE:

•   $XDG_CONFIG_HOME is ~/.config if it has not been overridden

•   %APPDATA% is usually <your user directory>\AppData

    NOTE: On Windows, there is a default config created by the installer, but on any other platform you must create the file yourself.

  Syntax

The config file is a simple text file and should contain one command-line option (omitting the dashes) per line in the format:

option=value

or for an option without value:

option

NOTE: Any quotes used will be part of the value, so only use them when the value needs them, e.g. when specifying a player with a path which contains spaces.

  Example

# Player options
player=mpv --cache 2048
player-no-close

NOTE: Full player paths are supported via configuration file options such as player="C:\mpv-x86_64\mpv"

PLUGIN SPECIFIC CONFIGURATION FILE

You may want to use specific options for some plugins only. This can be accomplished by placing those settings inside a plugin specific config file. Options inside these config files will override the main config file when a URL matching the plugin is used.

Streamlink expects this config to be named like the main config but with .<plugin name> attached to the end.

  Examples
Platform | Location
Unix-like (POSIX) | $XDG_CONFIG_HOME/streamlink/config.twitch ~/.streamlinkrc.ustreamtv
Windows | %APPDATA%\streamlink\streamlinkrc.youtube

Have a look at the list of plugins, or check the --plugins option to see the name of each built-in plugin.

SIDELOADING PLUGINS

Streamlink will attempt to load standalone plugins from these directories:
Platform | Location
Unix-like (POSIX) | $XDG_CONFIG_HOME/streamlink/plugins
Windows | %APPDATA%\streamlink\plugins

NOTE: If a plugin is added with the same name as a built-in plugin, then the added plugin will take precedence. This is useful if you want to upgrade plugins independently of the Streamlink version.

WARNING: If one of the sideloaded plugins fails to load, eg. due to a SyntaxError being raised by the parser, this exception will not get caught by Streamlink and the execution will stop, even if the input stream URL does not match the faulty plugin.

PLUGIN SPECIFIC USAGE

  Authenticating with Crunchyroll

Crunchyroll requires authenticating with a premium account to access some of their content. To do so, the plugin provides a couple of options to input your information, --crunchyroll-username and --crunchyroll-password.

You can login like this:

$ streamlink --crunchyroll-username=xxxx --crunchyroll-password=xxx https://crunchyroll.com/a-crunchyroll-episode-link

NOTE: If you omit the password, streamlink will ask for it.

Once logged in, the plugin makes sure to save the session credentials to avoid asking your username and password again.

Nevertheless, these credentials are valid for a limited amount of time, so it might be a good idea to save your username and password in your configuration file anyway.

WARNING: The API this plugin uses isn't supposed to be available on desktop computers. The plugin tries to blend in as a valid device using custom headers and following the API's usual flow (e.g. reusing credentials), but this does not assure that your account will be safe from being spotted for unusual behavior.

  HTTP proxy with Crunchyroll

To be able to stream region locked content, you can use Streamlink's proxy options, which are described in the Proxy Support section.

When doing this, it's possible that access to the stream will still be denied; this can happen because the session and credentials used by the plugin were obtained while being logged from your own region, and the server still assumes you're in that region.

For cases like this, the plugin provides the --crunchyroll-purge-credentials option, which removes your saved session and credentials and tries to log in again using your username and password.

  Authenticating with FunimationNow

Like Crunchyroll, the FunimationNow plugin requires authenticating with a premium account to access some content: --funimation-email, --funimation-password. In addition, this plugin requires the incap_ses cookie to be sent with each HTTP request (see issue #2088). This unique session cookie can be found in your browser and sent via the --http-cookie option.

$ streamlink --funimation-email='xxx' --funimation-password='xxx' --http-cookie 'incap_ses_xxx=xxxx=' https://funimation.com/shows/show/an-episode-link

NOTE: There are multiple ways to retrieve the required cookie. For more information on browser cookies, please consult the following:

•   What are cookies?

PLAYING BUILT-IN STREAMING PROTOCOLS DIRECTLY

There are many types of streaming protocols used by services today and Streamlink supports most of them. It's possible to tell Streamlink to access a streaming protocol directly instead of relying on a plugin to extract the streams from a URL for you.

A protocol can be accessed directly by specifying it in the URL format:

protocol://path [key=value]

Accessing a stream that requires extra parameters to be passed along (e.g. RTMP):

$ streamlink "rtmp://streaming.server.net/playpath live=1 swfVfy=http://server.net/flashplayer.swf"

When passing parameters to the built-in stream plugins, the values will either be treated as plain strings, as is the case in the example above for swfVry, or they will be interpreted as Python literals. For example, you can pass a Python dict or Python list as one of the parameters.

$ streamlink "rtmp://streaming.server.net/playpath conn=['B:1', 'S:authMe', 'O:1', 'NN:code:1.23', 'NS:flag:ok', 'O:0']"
$ streamlink "hls://streaming.server.net/playpath params={'token': 'magicToken'}"

In the examples above, conn will be passed as a Python list:

['B:1', 'S:authMe', 'O:1', 'NN:code:1.23', 'NS:flag:ok', 'O:0']

and params will be passed as a Python dict:

{'token': 'magicToken'}

Most streaming protocols only require you to pass a simple URL. This is an Adobe HDS stream:

$ streamlink hds://streaming.server.net/playpath/manifest.f4m

  Supported streaming protocols
Name | Prefix
Adobe HTTP Dynamic Streaming | hds://
Akamai HD Adaptive Streaming | akamaihd://
Apple HTTP Live Streaming | hls:// [1]
MPEG-DASH [2] | dash://
Real Time Messaging Protocol | rtmp:// rtmpe:// rtmps:// rtmpt:// rtmpte://
Progressive HTTP, HTTPS, etc | httpstream:// [1]

[1] supports local files using the file:// protocol

[2] Dynamic Adaptive Streaming over HTTP

PROXY SUPPORT

You can use the --http-proxy or --https-proxy options to change the proxy server that Streamlink will use for HTTP and HTTPS requests respectively. For convenience reasons, --http-proxy will automatically set the value of --https-proxy as well, if it has not been set by the user.

Both HTTP and SOCKS proxies are supported, as well as authentication in each of them.

NOTE: When using a SOCKS proxy, the socks4 and socks5 schemes mean that DNS lookups are done locally, rather than on the proxy server. To have the proxy server perform the DNS lookups, the socks4a and socks5h schemes should be used instead.

$ streamlink --http-proxy "http://user:pass@10.10.1.10:3128/" --https-proxy "socks5://10.10.1.10:1242"
$ streamlink --http-proxy "socks4a://10.10.1.10:1235" --https-proxy "socks5h://10.10.1.10:1234"

COMMAND-LINE USAGE

$ streamlink [OPTIONS] <URL> [STREAM]

  Positional arguments

URL A URL to attempt to extract streams from.

    Usually, the protocol of http(s) URLs can be omitted ("https://"), depending on the implementation of the plugin being used.

    Alternatively, the URL can also be specified by using the --url option.

STREAM
    Stream to play.

    Use best or worst for selecting the highest or lowest available quality.

    Fallback streams can be specified by using a comma-separated list:

    "720p,480p,best"

    If no stream is specified and --default-stream is not used, then a list of available streams will be printed.

  General options

-h

--help
    Show this help message and exit.

-V

--version
    Show version number and exit.

--plugins
    Print a list of all currently installed plugins.

--plugin-dirs DIRECTORY
    Attempts to load plugins from these directories.

    Multiple directories can be used by separating them with a comma.

--can-handle-url URL
    Check if Streamlink has a plugin that can handle the specified URL.

    Returns status code 1 for false and 0 for true.

    Useful for external scripting.

--can-handle-url-no-redirect URL
    Same as --can-handle-url but without following redirects when looking up the URL.

--config FILENAME
    Load options from this config file.

    Can be repeated to load multiple files, in which case the options are merged on top of each other where the last config has highest priority.

-l LEVEL

--loglevel LEVEL
    Set the log message threshold.

    Valid levels are: none, error, warning, info, debug, trace

-Q

--quiet
    Hide all log output.

    Alias for "--loglevel none".

-j

--json
    Output JSON representations instead of the normal text output.

    Useful for external scripting.

--auto-version-check {yes,true,1,on,no,false,0,off}
    Enable or disable the automatic check for a new version of Streamlink.

    Default is: "no".

--version-check
    Runs a version check and exits.

--locale LOCALE
    The preferred locale setting, for selecting the preferred subtitle and audio language.

    The locale is formatted as [language_code]_[country_code], eg. en_US or es_ES.

    Default is: system locale.

  Player options

-p COMMAND

--player COMMAND
    Player to feed stream data to. By default, VLC will be used if it can be found in its default location.

    This is a shell-like syntax to support using a specific player:

    streamlink --player=vlc <url> [stream]

    Absolute or relative paths can also be passed via this option in the event the player's executable can not be resolved:

    streamlink --player=/path/to/vlc <url> [stream]
    streamlink --player=./vlc-player/vlc <url> [stream]

    To use a player that is located in a path with spaces you must quote the parameter or its value:

    streamlink "--player=/path/with spaces/vlc" <url> [stream]
    streamlink --player "C:\path\with spaces\mpc-hc64.exe" <url> [stream]

    Options may also be passed to the player. For example:

    streamlink --player "vlc --file-caching=5000" <url> [stream]

    As an alternative to this, see the --player-args parameter, which does not log any custom player arguments.

-a ARGUMENTS

--player-args ARGUMENTS
    This option allows you to customize the default arguments which are put together with the value of --player to create a command to execute.

    It's usually enough to only use --player instead of this unless you need to add arguments after the player's input argument or if you don't want any of the player arguments to be logged.

    The value can contain formatting variables surrounded by curly braces, { and }. If you need to include a brace character, it can be escaped by doubling, e.g. {{ and }}.

    Formatting variables available:

{playerinput}
    This is the input that the player will use. For standard input (stdin), it is -, but it can also be a URL, depending on the options used.

{filename}
    The old fallback variable name with the same functionality.

    Example:

    streamlink -p vlc -a "--play-and-exit {playerinput}" <url> [stream]

    NOTE: When neither of the variables are found, {playerinput} will be appended to the whole parameter value, to ensure that the player always receives an input argument.

-v

--verbose-player
    Allow the player to display its console output.

-n

--player-fifo

--fifo
    Make the player read the stream through a named pipe instead of the stdin pipe.

--player-http
    Make the player read the stream through HTTP instead of the stdin pipe.

--player-continuous-http
    Make the player read the stream through HTTP, but unlike --player-http it will continuously try to open the stream if the player requests it.

    This makes it possible to handle stream disconnects if your player is capable of reconnecting to a HTTP stream. This is usually done by setting your player to a "repeat mode".

--player-external-http
    Serve stream data through HTTP without running any player. This is useful to allow external devices like smartphones or streaming boxes to watch streams they wouldn't be able to otherwise.

    Behavior will be similar to the continuous HTTP option, but no player program will be started, and the server will listen on all available connections instead of just in the local (loopback) interface.

    The URLs that can be used to access the stream will be printed to the console, and the server can be interrupted using CTRL-C.

--player-external-http-port PORT
    A fixed port to use for the external HTTP server if that mode is enabled. Omit or set to 0 to use a random high ( >1024) port.

--player-passthrough TYPES
    A comma-delimited list of stream types to pass to the player as a URL to let it handle the transport of the stream instead.

    Stream types that can be converted into a playable URL are:

•   hls

•   http

•   rtmp

    Make sure your player can handle the stream type when using this.

--player-no-close
    By default Streamlink will close the player when the stream ends. This is to avoid "dead" GUI players lingering after a stream ends.

    It does however have the side-effect of sometimes closing a player before it has played back all of its cached data.

    This option will instead let the player decide when to exit.

-t TITLE

--title TITLE
    This option allows you to supply a title to be displayed in the title bar of the window that the video player is launched in.

    This value can contain formatting variables surrounded by curly braces, { and }. If you need to include a brace character, it can be escaped by doubling, e.g. {{ and }}.

    This option is only supported for the following players: mpv, potplayer, vlc.

VLC specific information:
    VLC has certain codes you can use inside your title. These are accessible inside --title by using a backslash before the dollar sign VLC uses to denote a format character.

    e.g. to put the current date in your VLC window title, the string "$A" could be inserted inside your --title string.

    A full list of the format codes VLC uses is available here: https://wiki.videolan.org/Documentation:Format_String/

mpv specific information:
    mpv has certain codes you can use inside your title. These are accessible inside --title by using a backslash before the dollar sign mpv uses to denote a format character.

    e.g. to put the current version of mpv running inside your mpv window title, the string "${{mpv-version}}" could be inserted inside your --title string.

    A full list of the format codes mpv uses is available here: https://mpv.io/manual/stable/#property-list

    Formatting variables available to use in --title:

{title}
    If available, this is the title of the stream. Otherwise, it is the string "Unknown Title"

{author}
    If available, this is the author of the stream. Otherwise, it is the string "Unknown Author"

{category}
    If available, this is the category the stream has been placed into.

•   For Twitch, this is the game being played

•   For YouTube, it's the category e.g. Gaming, Sports, Music...

    Otherwise, it is the string "No Category"

{game}
    This is just a synonym for {category} which may make more sense for gaming oriented platforms. "Game being played" is a way to categorize the stream, so it doesn't need its own separate handling.

{url}
    URL of the stream.

    Examples:

    streamlink -p vlc --title "{title} -!- {author} -!- {category} \$A" <url> [stream]
    streamlink -p mpv --title "{title} -- {author} -- {category} -- (\${{mpv-version}})" <url> [stream]

  File output options

-o FILENAME

--output FILENAME
    Write stream data to FILENAME instead of playing it.

    You will be prompted if the file already exists.

-f

--force
    When using -o or -r, always write to file even if it already exists.

--force-progress
    When using -o or -r, show the download progress bar even if there is no terminal.

-O

--stdout
    Write stream data to stdout instead of playing it.

-r FILENAME

--record FILENAME
    Open the stream in the player, while at the same time writing it to FILENAME.

    You will be prompted if the file already exists.

-R FILENAME

--record-and-pipe FILENAME
    Write stream data to stdout, while at the same time writing it to FILENAME.

    You will be prompted if the file already exists.

  Stream options

--url URL
    A URL to attempt to extract streams from.

    Usually, the protocol of http(s) URLs can be omitted (https://), depending on the implementation of the plugin being used.

    This is an alternative to setting the URL using a positional argument and can be useful if set in a config file.

--default-stream STREAM
    Stream to play.

    Use best or worst for selecting the highest or lowest available quality.

    Fallback streams can be specified by using a comma-separated list:

    "720p,480p,best"

    This is an alternative to setting the stream using a positional argument and can be useful if set in a config file.

--stream-url
    If possible, translate the resolved stream to a URL and print it.

--retry-streams DELAY
    Retry fetching the list of available streams until streams are found while waiting DELAY second(s) between each attempt. If unset, only one attempt will be made to fetch the list of streams available.

    The number of fetch retry attempts can be capped with --retry-max.

--retry-max COUNT
    When using --retry-streams, stop retrying the fetch after COUNT retry attempt(s). Fetch will retry infinitely if COUNT is zero or unset.

    If --retry-max is set without setting --retry-streams, the delay between retries will default to 1 second.

--retry-open ATTEMPTS
    After a successful fetch, try ATTEMPTS time(s) to open the stream until giving up.

    Default is: 1.

--stream-types TYPES

--stream-priority TYPES
    A comma-delimited list of stream types to allow.

    The order will be used to separate streams when there are multiple streams with the same name but different stream types. Any stream type not listed will be omitted from the available streams list. A * can be used as a wildcard to match any other type of stream, eg. muxed-stream.

    Default is: "rtmp,hls,hds,http,akamaihd,*".

--stream-sorting-excludes STREAMS
    Fine tune the best and worst stream name synonyms by excluding unwanted streams.

    If all of the available streams get excluded, best and worst will become inaccessible and new special stream synonyms best-unfiltered and worst-unfiltered can be used as a fallback selection method.

    Uses a filter expression in the format:

    [operator]<value>

    Valid operators are >, >=, < and <=. If no operator is specified then equality is tested.

    For example this will exclude streams ranked higher than "480p":

    ">480p"

    Multiple filters can be used by separating each expression with a comma.

    For example this will exclude streams from two quality types:

    ">480p,>medium"

  Stream transport options

--hds-live-edge SECONDS
    The time live HDS streams will start from the edge of stream.

    Default is: 10.0.

--hds-segment-attempts ATTEMPTS
    How many attempts should be done to download each HDS segment before giving up.

    Default is: 3.

--hds-segment-threads THREADS
    The size of the thread pool used to download HDS segments. Minimum value is 1 and maximum is 10.

    Default is: 1.

--hds-segment-timeout TIMEOUT
    HDS segment connect and read timeout.

    Default is: 10.0.

--hds-timeout TIMEOUT
    Timeout for reading data from HDS streams.

    Default is: 60.0.

--hls-live-edge SEGMENTS
    How many segments from the end to start live HLS streams on.

    The lower the value the lower latency from the source you will be, but also increases the chance of buffering.

    Default is: 3.

--hls-segment-stream-data
    Immediately write segment data into output buffer while downloading.

--hls-segment-attempts ATTEMPTS
    How many attempts should be done to download each HLS segment before giving up.

    Default is: 3.

--hls-playlist-reload-attempts ATTEMPTS
    How many attempts should be done to reload the HLS playlist before giving up.

    Default is: 3.

--hls-playlist-reload-time TIME
    Set a custom HLS playlist reload time value, either in seconds or by using one of the following keywords:

    segment: The duration of the last segment in the current playlist
    live-edge: The sum of segment durations of the live edge value minus one
    default: The playlist's target duration metadata

    Default is: default.

--hls-segment-threads THREADS
    The size of the thread pool used to download HLS segments. Minimum value is 1 and maximum is 10.

    Default is: 1.

--hls-segment-timeout TIMEOUT
    HLS segment connect and read timeout.

    Default is: 10.0.

--hls-segment-ignore-names NAMES
    A comma-delimited list of segment names that will get filtered out.

    Example: --hls-segment-ignore-names 000,001,002

    This will ignore every segment that ends with 000.ts, 001.ts and 002.ts

    Default is: None.

--hls-segment-key-uri URI
    URI to segment encryption key. If no URI is specified, the URI contained in the segments will be used.

    URI can be templated using the following variables, which will be replaced with its respective part from the source segment URI:

    {url} {scheme} {netloc} {path} {query}

    Examples:

    --hls-segment-key-uri "https://example.com/hls/encryption_key"
    --hls-segment-key-uri "{scheme}://1.2.3.4{path}{query}"
    --hls-segment-key-uri "{scheme}://{netloc}/custom/path/to/key"

    Default is: None.

--hls-audio-select CODE
    Selects a specific audio source or sources, by language code or name, when multiple audio sources are available. Can be * to download all audio sources.

    Examples:

    --hls-audio-select "English,German"
    --hls-audio-select "en,de"
    --hls-audio-select "*"

    NOTE: This is only useful in special circumstances where the regular locale option fails, such as when multiple sources of the same language exists.

--hls-timeout TIMEOUT
    Timeout for reading data from HLS streams.

    Default is: 60.0.

--hls-start-offset [HH:]MM:SS
    Amount of time to skip from the beginning of the stream. For live streams, this is a negative offset from the end of the stream (rewind).

    Default is: 00:00:00.

--hls-duration [HH:]MM:SS
    Limit the playback duration, useful for watching segments of a stream. The actual duration may be slightly longer, as it is rounded to the nearest HLS segment.

    Default is: unlimited.

--hls-live-restart
    Skip to the beginning of a live stream, or as far back as possible.

--http-stream-timeout TIMEOUT
    Timeout for reading data from HTTP streams.

    Default is: 60.0.

--ringbuffer-size SIZE
    The maximum size of ringbuffer. Add a M or K suffix to specify mega or kilo bytes instead of bytes.

    The ringbuffer is used as a temporary storage between the stream and the player. This is to allows us to download the stream faster than the player wants to read it.

    The smaller the size, the higher chance of the player buffering if there are download speed dips and the higher size the more data we can use as a storage to catch up from speed dips.

    It also allows you to temporary pause as long as the ringbuffer doesn't get full since we continue to download the stream in the background.

    Default is: "16M".

    NOTE: A smaller size is recommended on lower end systems (such as Raspberry Pi) when playing stream types that require some extra processing (such as HDS) to avoid unnecessary background processing.

--rtmp-proxy PROXY
    A SOCKS proxy that RTMP streams will use.

    Example: 127.0.0.1:9050

--rtmp-rtmpdump FILENAME
    RTMPDump is used to access RTMP streams. You can specify the location of the rtmpdump executable if it is not in your PATH.

    Example: "/usr/local/bin/rtmpdump"

--rtmp-timeout TIMEOUT
    Timeout for reading data from RTMP streams.

    Default is: 60.0.

--stream-segment-attempts ATTEMPTS
    How many attempts should be done to download each segment before giving up.

    This is generic option used by streams not covered by other options, such as stream protocols specific to plugins, e.g. UStream.

    Default is: 3.

--stream-segment-threads THREADS
    The size of the thread pool used to download segments. Minimum value is 1 and maximum is 10.

    This is generic option used by streams not covered by other options, such as stream protocols specific to plugins, e.g. UStream.

    Default is: 1.

--stream-segment-timeout TIMEOUT
    Segment connect and read timeout.

    This is generic option used by streams not covered by other options, such as stream protocols specific to plugins, e.g. UStream.

    Default is: 10.0.

--stream-timeout TIMEOUT
    Timeout for reading data from streams.

    This is generic option used by streams not covered by other options, such as stream protocols specific to plugins, e.g. UStream.

    Default is: 60.0.

--subprocess-cmdline
    Print the command-line used internally to play the stream.

    This is only available on RTMP streams.

--subprocess-errorlog
    Log possible errors from internal subprocesses to a temporary file. The file will be saved in your systems temporary directory.

    Useful when debugging rtmpdump related issues.

--subprocess-errorlog-path PATH
    Log the subprocess errorlog to a specific file rather than a temporary file. Takes precedence over subprocess-errorlog.

    Useful when debugging rtmpdump related issues.

--ffmpeg-ffmpeg FILENAME
    FFMPEG is used to access or mux separate video and audio streams. You can specify the location of the ffmpeg executable if it is not in your PATH.

    Example: "/usr/local/bin/ffmpeg"

--ffmpeg-verbose
    Write the console output from ffmpeg to the console.

--ffmpeg-verbose-path PATH
    Path to write the output from the ffmpeg console.

--ffmpeg-fout OUTFORMAT
    Set output file format.

    Example: "mpegts"

--ffmpeg-video-transcode CODEC
    When muxing streams transcode the video to this CODEC.

    Default is: "copy".

    Example: "h264"

--ffmpeg-audio-transcode CODEC
    When muxing streams transcode the audio to this CODEC.

    Default is: "copy".

    Example: "aac"

--ffmpeg-copyts
    Forces the -copyts ffmpeg option and does not remove the initial start time offset value.

--ffmpeg-start-at-zero
    Enable the -start_at_zero ffmpeg option when using copyts.

--mux-subtitles
    Automatically mux available subtitles into the output stream.

    Needs to be supported by the used plugin.

    Supported plugins: funimationnow, pluzz, rtve, svtplay, vimeo

  HTTP options

--http-proxy HTTP_PROXY
    A HTTP proxy to use for all HTTP requests, including WebSocket connections. By default this proxy will be used for all HTTPS requests too.

    Example: "http://hostname:port/"

--https-proxy HTTPS_PROXY
    A HTTPS capable proxy to use for all HTTPS requests.

    Example: "https://hostname:port/"

--http-cookie KEY=VALUE
    A cookie to add to each HTTP request.

    Can be repeated to add multiple cookies.

--http-header KEY=VALUE
    A header to add to each HTTP request.

    Can be repeated to add multiple headers.

--http-query-param KEY=VALUE
    A query parameter to add to each HTTP request.

    Can be repeated to add multiple query parameters.

--http-ignore-env
    Ignore HTTP settings set in the environment such as environment variables (HTTP_PROXY, etc) or ~/.netrc authentication.

--http-no-ssl-verify
    Don't attempt to verify SSL certificates.

    Usually a bad idea, only use this if you know what you're doing.

--http-disable-dh
    Disable Diffie Hellman key exchange

    Usually a bad idea, only use this if you know what you're doing.

--http-ssl-cert FILENAME
    SSL certificate to use.

    Expects a .pem file.

--http-ssl-cert-crt-key CRT_FILENAME KEY_FILENAME
    SSL certificate to use.

    Expects a .crt and a .key file.

--http-timeout TIMEOUT
    General timeout used by all HTTP requests except the ones covered by other options.

    Default is: 20.0.

  Plugin options

  Abweb

--abweb-username USERNAME
    The username associated with your ABweb account, required to access any ABweb stream.

--abweb-password PASSWORD
    A ABweb account password to use with --abweb-username.

--abweb-purge-credentials
    Purge cached ABweb credentials to initiate a new session and reauthenticate.

  Afreeca

--afreeca-username USERNAME
    The username used to register with afreecatv.com.

--afreeca-password PASSWORD
    A afreecatv.com account password to use with --afreeca-username.

--afreeca-purge-credentials
    Purge cached AfreecaTV credentials to initiate a new session and reauthenticate.

  Animelab

--animelab-email EMAIL
    The email address used to register with animelab.com.

--animelab-password PASSWORD
    A animelab.com account password to use with --animelab-email.

  Bbciplayer

--bbciplayer-username USERNAME
    The username used to register with bbc.co.uk.

--bbciplayer-password PASSWORD
    A bbc.co.uk account password to use with --bbciplayer-username.

--bbciplayer-hd
    Prefer HD streams over local SD streams, some live programmes may not be broadcast in HD.

  Btsports

--btsports-email EMAIL
    The email associated with your BT Sport account, required to access any BT Sport stream.

--btsports-password PASSWORD
    Your BT Sport account password.

  Clubbingtv

--clubbingtv-username
    The username used to register with Clubbing TV.

--clubbingtv-password
    A Clubbing TV account password to use with --clubbingtv-username.

  Crunchyroll

--crunchyroll-username USERNAME
    A Crunchyroll username to allow access to restricted streams.

--crunchyroll-password [PASSWORD]
    A Crunchyroll password for use with --crunchyroll-username.

    If left blank you will be prompted.

--crunchyroll-purge-credentials
    Purge cached Crunchyroll credentials to initiate a new session and reauthenticate.

--crunchyroll-session-id SESSION_ID
    Set a specific session ID for crunchyroll, can be used to bypass region restrictions. If using an authenticated session ID, it is recommended that the authentication parameters be omitted as the session ID is account specific.

    NOTE: The session ID will be overwritten if authentication is used and the session ID does not match the account.

  Funimationnow

--funimation-email
    Email address for your Funimation account.

--funimation-password
    Password for your Funimation account.

--funimation-language
    The audio language to use for the stream; japanese or english.

    Default is: "english".

  Liveedu

--liveedu-email EMAIL
    The email address used to register with liveedu.tv.

--liveedu-password PASSWORD
    A LiveEdu account password to use with --liveedu-email.

  Nicolive

--niconico-email EMAIL
    The email or phone number associated with your Niconico account

--niconico-password PASSWORD
    The password of your Niconico account

--niconico-user-session VALUE
    Value of the user-session token (can be used in case you do not want to put your password here)

--niconico-timeshift-offset [HH:]MM:SS
    Amount of time to skip from the beginning of a stream. Default is 00:00:00.

  Openrectv

--openrectv-email EMAIL
    The email associated with your openrectv account, required to access any openrectv stream.

--openrectv-password PASSWORD
    An openrectv account password to use with --openrectv-email.

  Pixiv

--pixiv-sessionid SESSIONID
    The pixiv.net sessionid that's used in pixivs PHPSESSID cookie. can be used instead of the username/password login process.

--pixiv-devicetoken DEVICETOKEN
    The pixiv.net device token that's used in pixivs device_token cookie. can be used instead of the username/password login process.

--pixiv-purge-credentials
    Purge cached Pixiv credentials to initiate a new session and reauthenticate.

--pixiv-performer USER
    Select a co-host stream instead of the owner stream.

  Sbscokr

--sbscokr-id CHANNELID
    Channel ID to play.

    Example:

    streamlink http://play.sbs.co.kr/onair/pc/index.html best --sbscokr-id S01

  Schoolism

--schoolism-email EMAIL
    The email associated with your Schoolism account, required to access any Schoolism stream.

--schoolism-password PASSWORD
    A Schoolism account password to use with --schoolism-email.

--schoolism-part PART
    Play part number PART of the lesson, or assignment feedback video.

    Defaults is 1.

  Steam

--steam-email EMAIL
    A Steam account email address to access friends/private streams

--steam-password PASSWORD
    A Steam account password to use with --steam-email.

  Streann

--streann-url URL
    Source URL where the iframe is located, only required for direct URLs of ott.streann.com

  Tvplayer

--tvplayer-email EMAIL
    The email address used to register with tvplayer.com.

--tvplayer-password PASSWORD
    The password for your tvplayer.com account.

  Twitch

--twitch-disable-hosting
    Do not open the stream if the target channel is hosting another channel.

--twitch-disable-ads
    Skip embedded advertisement segments at the beginning or during a stream. Will cause these segments to be missing from the stream.

--twitch-disable-reruns
    Do not open the stream if the target channel is currently broadcasting a rerun.

--twitch-low-latency
    Enables low latency streaming by prefetching HLS segments. Sets --hls-segment-stream-data to true and --hls-live-edge to 2, if it is higher. Reducing --hls-live-edge to 1 will result in the lowest latency possible.

    Low latency streams have to be enabled by the broadcasters on Twitch themselves. Regular streams can cause buffering issues with this option enabled.

    NOTE: The caching/buffering settings of the chosen player may need to be adjusted as well. Please refer to the player's own documentation for the required parameters and its configuration. Player parameters can be set via Streamlink's --player or --player-args parameters.

  Ustreamtv

--ustream-password PASSWORD
    A password to access password protected UStream.tv channels.

  Ustvnow

--ustvnow-username USERNAME
    Your USTV Now account username

--ustvnow-password PASSWORD
    Your USTV Now account password

  Wwenetwork

--wwenetwork-email EMAIL
    The email associated with your WWE Network account, required to access any WWE Network stream.

--wwenetwork-password PASSWORD
    A WWE Network account password to use with --wwenetwork-email.

  Yupptv

--yupptv-boxid BOXID
    The yupptv.com boxid that's used in the BoxId cookie. Can be used instead of the username/password login process.

--yupptv-yuppflixtoken YUPPFLIXTOKEN
    The yupptv.com yuppflixtoken that's used in the YuppflixToken cookie. Can be used instead of the username/password login process.

--yupptv-purge-credentials
    Purge cached YuppTV credentials to initiate a new session and reauthenticate.

  Zattoo

--zattoo-email EMAIL
    The email associated with your zattoo account, required to access any zattoo stream.

--zattoo-password PASSWORD
    A zattoo account password to use with --zattoo-email.

--zattoo-purge-credentials
    Purge cached zattoo credentials to initiate a new session and reauthenticate.

--zattoo-stream-types TYPES
    A comma-delimited list of stream types which should be used, the following types are allowed:

•   dash

•   hls

•   hls5

    Default is: "hls".

AUTHOR
Streamlink Contributors

COPYRIGHT
2020, Streamlink